#include <kosSyst.h>
#include <kosFile.h>
#include "core.h"

void eButtonClick(Button* btn) {

}

//  
void draw_rectangle(int x, int y, int sizex, int sizey, int color) {
	x = x*65536+sizex;
	y = y*65536+sizey;
	__asm{
		push 13
		pop eax
		mov ebx, x
		mov ecx, y
		mov edx, color
		int 0x40
	}
}

//  DLL
dll_import* load_dll(char* path) {
	dll_import* result;
	__asm{
		push 68
		pop eax
		mov ebx, 19
		mov ecx, path
		int 0x40
		mov result, eax
	}
	
	return result;
}



void Window::update() {
	draw(false);
}

void Window::draw() {
	draw(false);
}

void Window::draw(bool flagUpdate) {
	if (flagUpdate) kos_WindowRedrawStatus(1);

	kos_DefineAndDrawWindow(x,y,sizeX,sizeY, mainAreaType,mainAreaColour,headerType,headerColour,(Dword)header);

	int i = 0;

	for (i=0;i<50;i++) {
		if (buttons[i] != NULL) buttons[i]->draw();
		if (labels[i] != NULL) labels[i]->draw();
	}

	if (flagUpdate) kos_WindowRedrawStatus(2);
}

Window::Window() {
	x = 10;
	y = 10;
	sizeX = 500;
	sizeY = 500;
	mainAreaType = 0x33;
	mainAreaColour = COLOR_WHITE;
	headerType = 0;
	headerColour = COLOR_RED;
	header = (Dword)"Window";

	lastButtonId = 0;
	lastLabelId = 0;
}

void Window::waitForEvent() {
	int k_event;

	while(k_event=kos_WaitForEvent()) {
		switch (kos_WaitForEvent()) {
			case EM_WINDOW_REDRAW:
				draw();
			break;
			case EM_KEY_PRESS:
				Byte keyCode;
				kos_GetKey(keyCode);
			break;
			case 3:
				Dword buttonId;
				kos_GetButtonID(buttonId);
				//routeButtonClick(buttonId);

				if (buttonId == 2) kos_ExitApp();

				if (buttonId < 50 && buttons[buttonId] != NULL) {
					buttons[buttonId]->onclick(buttons[buttonId]);
				}

			break;
		}
	}
}

int Window::addControl(int type, Button* btn) {
	buttons[lastButtonId] = btn;
	lastButtonId++;
	
	return (lastButtonId-1);
}

int Window::addControl(int type, Label* lbl) {
	labels[lastLabelId] = lbl;
	lastLabelId++;
	
	return (lastLabelId-1);
}

Button::Button() {
	x = 0;
	y = 0;
	sizeX = 30;
	sizeY = 10;
	id = 0;
	color = COLOR_RED;
	hidden = false;
	onclick = eButtonClick;
}

void Button::draw() {
	if (!hidden) kos_DefineButton(x, y, sizeX, sizeY, id, color );
}

Label::Label() {
	x = 0;
	y = 0;
	id = 0;
	color = COLOR_BLACK;
	hidden = false;
	fontType = 0x80;
	text = "Test";
	textlen = 0;
}

void Label::draw() {
	if (!hidden) kos_WriteTextToWindow(x, y, fontType, color, text, textlen);
}